'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _fela = require('fela');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _context = require('./context');

var _context2 = _interopRequireDefault(_context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var keepKeys = function keepKeys(obj, keys) {
  return Object.keys(obj).filter(function (key) {
    return !keys.includes(key);
  }).reduce(function (acc, key) {
    return _extends({}, acc, _defineProperty({}, key, obj[key]));
  }, {});
};

var styled = function styled(BaseComponent) {
  return function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var Component = function Component(_ref, ctx) {
      var is = _ref.is,
          innerRef = _ref.innerRef,
          css = _ref.css,
          props = _objectWithoutProperties(_ref, ['is', 'innerRef', 'css']);

      var _ctx$context$ns = ctx[_context2.default.ns],
          renderer = _ctx$context$ns.renderer,
          theme = _ctx$context$ns.theme;

      var stylePropKeys = Object.keys(Component.propTypes || {});
      var styleProps = Object.assign({ theme: theme }, props);

      var rules = [].concat(args, [css]).map(function (a) {
        return typeof a !== 'function' ? function () {
          return a;
        } : a;
      }).filter(function (s) {
        return s !== null;
      });

      var className = renderer.renderRule(_fela.combineRules.apply(undefined, _toConsumableArray(rules)), styleProps);

      return (0, _react.createElement)(is || BaseComponent, Object.assign({}, keepKeys(props, stylePropKeys), {
        ref: innerRef,
        className: [props.className, className].join(' ').trim()
      }));
    };

    Component.contextTypes = _context2.default.types;

    return Component;
  };
};

exports.default = styled;